apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ jenkins_name }}
  name: {{ jenkins_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ jenkins_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ jenkins_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ jenkins_name }}
  strategy:
    recreateParams:
      timeoutSeconds: 900
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ jenkins_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ jenkins_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ jenkins_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      containers:
      - env:
        - name: DISABLE_ADMINISTRATIVE_MONITORS
          value: "{{ jenkins_disable_administrative_monitors }}"
        - name: INSTALL_PLUGINS
          value: "{{ jenkins_plugins | join(',') }}"
        - name: HTTP_PROXY
{% if proxy_host | default(False) %}
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
        - name: KUBERNETES_MASTER
          value: https://kubernetes.default:443
        - name: KUBERNETES_TRUST_CERTIFICATES
          value: "true"
        - name: JAVA_GC_OPTS
          value: -XX:+UseG1GC -XX:+UseStringDeduplication -XX:+ParallelRefProcEnabled -XX:+ExplicitGCInvokesConcurrent -XX:+UnlockDiagnosticVMOptions -XX:G1SummarizeRSetStatsPeriod=1 -XX:MaxMetaspaceExpansion=64M -XX:+UnlockExperimentalVMOptions -XX:G1NewSizePercent=20
        - name: JAVA_OPTS
          value: -Dhudson.tasks.MailSender.SEND_TO_UNKNOWN_USERS=true
        - name: JENKINS_SERVICE_NAME
          value: {{ jenkins_name }}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and not do_oc) %}
        - name: JENKINS_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: {{ jenkins_name }}-admin
{% endif %}
        - name: JNLP_SERVICE_NAME
          value: {{ jenkins_name }}-jnlp
        - name: OPENSHIFT_ENABLE_OAUTH
          value: "{{ 'true' if (k8s_flavor == "openshift" and do_oc) else 'false' }}"
        - name: OPENSHIFT_ENABLE_REDIRECT_PROMPT
          value: "{{ 'true' if (k8s_flavor == "openshift" and do_oc) else 'false' }}"
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='jenkins'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='jenkins'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 28
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /login
            port: 8080
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 10
        name: jenkins
        readinessProbe:
          httpGet:
            path: /login
            port: 8080
          initialDelaySeconds: 20
          periodSeconds: 20
          timeoutSeconds: 10
        resources:
          limits:
            cpu: "{{ jenkins_cpu_limit }}"
            memory: "{{ jenkins_memory_limit }}"
          requests:
            cpu: "{{ jenkins_cpu_request }}"
            memory: "{{ jenkins_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 28
          initialDelaySeconds: 60
          periodSeconds: 30
          tcpSocket:
            port: 8080
{% endif %}
        volumeMounts:
        - mountPath: /var/lib/jenkins
          name: data
        - mountPath: /var/lib/jenkins/caches
          name: cache
        - mountPath: /var/lib/jenkins/hudson.plugins.git.GitSCM.xml
          name: conf
          subPath: hudson.plugins.git.GitSCM.xml
{% if sonarqube_api_address | default(False) %}
        - mountPath: /var/lib/jenkins/hudson.plugins.sonar.SonarGlobalConfiguration.xml
          name: conf
          subPath: hudson.plugins.sonar.SonarGlobalConfiguration.xml
{% endif %}
{% if smtp_relay | default(False) or smtp_address | default(False) %}
        - mountPath: /var/lib/jenkins/hudson.tasks.Mailer.xml
          name: conf
          subPath: hudson.tasks.Mailer.xml
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
        - mountPath: /var/lib/jenkins/jenkins.model.JenkinsLocationConfiguration.xml
          name: conf
          subPath: jenkins.model.JenkinsLocationConfiguration.xml
{% endif %}
{% if proxy_host | default(False) or squid_address is defined %}
        - mountPath: /var/lib/jenkins/proxy.xml
          name: conf
          subPath: proxy.xml
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-infra
{% endif %}
{% if rwo_needs_fsgroup | default(False) or k8s_flavor == 'kubernetes' %}
      securityContext:
{% if k8s_flavor == 'kubernetes' %}
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% if rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% else %}
      securityContext: {}
{% endif %}
      serviceAccountName: {{ jenkins_name }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ jenkins_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - emptyDir: {}
        name: cache
      - configMap:
          defaultMode: 420
          name: {{ jenkins_name }}-config
        name: conf
      - name: data
        persistentVolumeClaim:
          claimName: {{ jenkins_name }}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='jenkins'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - jenkins
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='jenkins'].short"))[0] }}
        namespace: {{ jenkins_images_namespace }}
{% endif %}
  - type: ConfigChange
{% endif %}
